;********************************************************************
;                         Tomasz Jaboski                          *
;                 Mikrokontrolery PIC16F8x w praktyce               *
;                      Wydawnictwo BTC, www.btc.pl                  *
;********************************************************************

;obsuga klawiatury matrycowej- poaczenie z moduem AVT873 pokazane 
;na rysunku 8.5. Dodatkowo podaczony wywietlacz LCD tak jak 
;na rysunku 8.19. Po naciniciu klawisza na wywietlaczu wywietlany 
;jest kod klawisza klwisz 1 - kod 01, klawisz 2 - kod 02 itd.
#include 16f84.h
w_temp		equ 0ch		;rejestr zachowania W
st_temp		equ 0dh		;rejestr zachowania STATUS
l_msek		equ 0eh		;licznik opnie czasu
l_kol		equ 0fh		;licznik kolumn
z_bit 		equ 10h
kod		equ 11h
l_opoz        	equ 12h
TMP		equ 13h
i		equ 14h
temp		equ 15h
temp1		equ 16h
dana 		equ 17h
dzies 		equ 18h
jedn		equ 19h
#define E	porta,1
#define RS	porta,0
#define o_kl	z_bit,0
#define	pu_kl	z_bit,1
#define pw_kl	z_bit,2
#define b_opoz	z_bit,3
	
		org 0
		goto _start

		org 0004
_int		movwf w_temp	;w_temp <- w
		swapf status,w	;w <-status
		movwf st_temp	;st_temp <-w
		
		bcf RP0		;bank0		

		bcf T0IF  	;zeruj flage przerwania od t0
		movlw .130	;laduj t0
		movwf tmr0
		
		btfss b_opoz
		goto n_opoz
		decf l_opoz,f
		movf l_opoz,w
		btfsc Z
		bcf b_opoz
				
n_opoz		btfss o_kl	;czy bit o_kl wyzerowany
		goto _odtworz	;poprzedni odczyt klawiatury nie zakoczony
		
		incf l_msek,f
		movf l_msek,w
		xorlw .20
		btfss Z		;nie mino 20msek
		goto _odtworz

		clrf l_msek
		btfsc pu_kl	;sprawdzenie czy poprzednio klawisz puszczony 
		goto _spr_pw	;klawisz puszczony  


		clrf porta	;sprawdzenie czy wszystkie klawisze puszczone
		nop
		movf portb,w
		andlw 0f0h
		xorlw 0f0h
		btfsc Z
		bsf pu_kl	;klawisz puszczony
		movlw 1ch	;deaktywacja linii
		movwf porta
		goto _odtworz

_spr_pw		btfsc pw_kl	;czy juz bylo sprawdzane wcisniecie
		goto _spr_dr	;sprawdzenie drugi raz

		clrf porta	;sprawdzenie czy jaki klawisz wcisniety
		nop
		movf portb,w
		andlw 0f0h
		xorlw 0f0h
		btfss Z
		bsf pw_kl	;znacznik - klawisz wcisniety
		movlw 1ch
		movwf porta	;deaktywacja linii
		goto _odtworz

_spr_dr		clrw		;sprawdzenie ktry klawisz wcinity
		clrf l_kol
		call spr_kl	;sprawd czy klawisze wcinite
		btfss Z
		goto _tkod

		movlw .1
		movwf l_kol
		call spr_kl	;sprawd czy klawisze wcinite
		btfss Z
		goto _tkod
		
		movlw .2
		movwf l_kol
		call spr_kl	;sprawd czy klawisze wciniete
		btfsc Z
		goto _blad		

_tkod		bcf o_kl	;sprawdznie klawiatury zablokowane do odczytania kodu
		bcf pu_kl	;wartoci pocztkowe bitw 
		bcf pw_kl
		comf kod,f
		swapf kod,w	
		andlw 0fh
		movwf kod

		movf l_kol,w
		btfsc Z
		goto _odtworz	;kod klawisza w zmiennej kod
		xorlw .1
		btfsc Z
		goto _kod_kol2
		movf kod,w
		addlw .16
		movwf kod
		goto _odtworz

_kod_kol2	movf kod,w
		addlw .8
		movwf kod
		goto _odtworz

_blad		bcf pu_kl	;zerowanie flag
		bcf pw_kl
		;odtworzenie rejestrw W i status
_odtworz	swapf st_temp,w	;w <- st_temp
		movwf status	;status <- w
		swapf w_temp,f
		swapf w_temp,w	;w <- w_temp	
		retfie

_poz		addwf pcl,f
		dt 18h,14h,0ch

	

spr_kl		call _poz	;aktywacja linii
		movwf porta
		nop
		nop
		movf portb,w	;czytanie linii RB4..RB7
		andlw 0f0h
		movwf kod	;zapisz
	
		movlw 1ch	;deaktywacja linii
		movwf porta

		movf kod,w
		xorlw 0f0h	;spr stanu klawisza
		
		return

_opoznienie	movwf l_opoz	;liczba milisekund
		movlw .130	;adowanie licznika
		movwf tmr0
		bsf b_opoz	;start zliczania
et_opoz		btfsc b_opoz	;czekaj na wyzerowanie b_opoz
		goto et_opoz
		return		

_klawiatura	bsf o_kl	;start sprawdzania klawiszy
et_klaw		btfsc o_kl	;klawisz przycinity
		goto et_klaw
		call _konw_kod	;konwersja kodu
		movwf kod
		return

_konw_kod	movf kod,w	; konwersja kodu 
		addwf pcl,f
		dt 0ffh,1,4,0ff,7,0ff,0ff,0ff,10
		dt 2,5,0ff,8,0ff,0ff,0ff,0,3,6,0ff,9,0ff,0ff,0ff,11

_start		bcf RP0		;bank 0
		clrf porta
		movlw 0f0h
		movwf portb
		bsf RP0		;bank1
		movlw .1	;option_reg=1 preskaler do TMR0 
		movwf option_reg;podzal preskalera 1:4
	
		movlw 0f0h
		movwf trisb
		clrf trisa
		bcf RP0		;bank0
		bcf o_kl	;nie mona sprawdzac klawiatury
		bcf pu_kl	;klawisz nie puszczony
		bcf pw_kl	; nie wykryte pierwsze wcisnicie

		movlw 0ffh
		movwf porta
		movwf portb
		
		clrf intcon
		movlw .130	;adowanie licznika
		movwf tmr0
		clrf l_msek	;zerowanie licznika odmierzania msek.

		bsf T0IE	;maska przerwania od licznika T0
		bsf GIE		;odblokowanie przerwa
		call iniLCD	; inicjacja wywietlacza LCD
eett		movlw 80h	;adres 00 wywietlacza LCD
		call wrcmd
		call _klawiatura; sprawdzenie klawiatury
		movf kod,w
		movwf TMP	; konewrsja hex->ascii (tylko dla cyfr)
		swapf TMP,w
		andlw 0fh
		addlw 30h
		call wrdata	;starsza cyfra
		movf kod,w
		andlw 0fh
		addlw 30h
		call wrdata	;mlodsza cyfra
		goto eett
	
		sleep		
		
;********************************************************************
;procedura konwersji liczby hex umieszczonej w W z zakresu 0..63h na 
;format dziesietny 0..99
;liczba jednostek w rejestrze jedn, liczba dziesiatek w rejestrze dzies
;********************************************************************
_konw		movwf  dana		;	dzies=lhex/10;
		movwf temp1		
		clrf  i
		movlw .8
		movwf temp
k01		rlf   temp1,1
		rlf   i,1
		movlw .10
		subwf i,W
		btfss C
		goto  k02
		movlw .10
		subwf i,1
		bsf   C
		btfss C
k02		bcf   C
		rlf   dzies,1
		decfsz temp,1
		goto  k01
			;	temp1=dzies*10;
		movlw .10
		movwf temp
		clrf  temp1
k03		movf  dzies,W
		addwf temp1,1
		decfsz temp,1
		goto  k03
			;	jedn=lhex-temp1;
		movf  temp1,W
		subwf dana,W
		movwf jedn
		return

;--------------------------------------------------------------------
;procedura zapisu danej (RS=1) lub instrukcji (RS=0)
;zapisywana osimiobitowa dana znajduje si w rejestrze W
;--------------------------------------------------------------------
wrdata		bsf RS
		goto et_wr
wrcmd		bcf RS		;RS=0 rejestr instrukcji IR
et_wr		movwf TMP	;instrukcja do TMP
		bsf E		;E=1
		swapf TMP,f	;zamiana polbajtow

		movlw 0f0h	;jedynki na starszym polbajcie
		iorwf TMP,w	;f0h.OR.TMP->W
		movwf portb	;na portb starszy polbajt
		bcf E		;E=0
		nop
		nop
		bsf E		;E=1

		swapf TMP,w	;ponowna zamiana polbajtow i wpisnie do W
		iorlw 0f0h	;f0h.OR.W->W
		movwf portb
		bcf E		;E=0
		btfsc RS	;jaki jest stan linii RS
		goto et_wrdata	;zapis danej
		movlw .2
		call _opoznienie	;opznienie 2msek dla instrukcji
		return

et_wrdata	movlw .1
		call _opoznienie	;opoznienie 100usek dla kodow znakow
		return
	
;--------------------------------------------------------------------
;porcedura inicjalizacji - interfejs 4bitowy
;--------------------------------------------------------------------
iniLCD		movlw .50	;opoznienie 50msek
		call _opoznienie
		
		bcf RS		;RS=0 rejestr IR
		bsf E		;E=1
		movlw .3
		movwf portb

		bcf E		;E=0
		movlw .5	;opoznienie 5msek
		call _opoznienie
		bsf E		;E=1
		nop		;ponowne wpisanie 3 modulu
		nop
		bcf E		;E=0
		movlw .1
		call _opoznienie	;czekaj 100usek
		bsf E		;E=1
		nop		;ponowne wpisanie 3 modulu
		nop
		bcf E		;E=0
		
		movlw .1
		call _opoznienie	;czekaj 100usek

		movlw 28h	;interfejs 4bitowy, 2linie znaki 5x7
		call wrcmd		
		movlw .8	;display off
		call wrcmd
		movlw .1	;display clear
		call wrcmd
		movlw .6	;entry mod
		call wrcmd
		movlw 0ch	;display on
		call wrcmd	
		return

		end
